/*
 * Gimbal
 * Copyright (C) 2024 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.gimbal.client.screen.widgets

import net.minecraft.client.gui.widget.SliderWidget
import net.minecraft.text.Text
import net.moonleay.gimbal.client.util.NumberUtil

class GimbalSliderWidget(
    x: Int,
    y: Int,
    width: Int,
    height: Int,
    private val text: Text,
    value: Double,
    private val lowerEnd: Double,
    private val upperEnd: Double,
    private val setValue: (Double) -> Unit,
) :
    SliderWidget(x, y, width, height, text, value) {
    init {
        this.message = this.text.copy()
            .append(": " + (NumberUtil.interpolate(this.value, 0.0, 1.0, this.lowerEnd, this.upperEnd).toInt()))
    }

    override fun updateMessage() {
        this.message = this.text.copy()
            .append(": " + (NumberUtil.interpolate(this.value, 0.0, 1.0, this.lowerEnd, this.upperEnd).toInt()))
    }

    override fun applyValue() {
        this.setValue(this.value)
    }
}
