/*
 * Gimbal
 * Copyright (C) 2024 moonleay
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

package net.moonleay.gimbal.client.util

object NumberUtil {

    /**
     * Interpolate a Position between two numbers
     */
    fun interpolate(number: Double, min: Double, max: Double, lowerEnd: Double, upperEnd: Double): Double {
        val toAddToMin = (0 - min) * -1
        val minMaxDiff = max - min
        val onePercent = minMaxDiff / 100.0
        val percentOfNumber = (number - toAddToMin) / onePercent

        val toAddToLowerEnd = (0 - lowerEnd) * -1
        val upperLowerDiff = upperEnd - lowerEnd
        val onePercentOfEnd = upperLowerDiff / 100.0
        return (percentOfNumber * onePercentOfEnd) + toAddToLowerEnd
    }
}
